// Soubor CPLX.CPP
// Priklad deklarace objektoveho typu bez predku

#include <math.h>
class cplx {				// Hlavicka tridy
	double re, im;			// Soukrome datove slozky (atributy)
public:					// Nasledujici slozku budou verejne
	double Re();			// Metody
	double Im();
	cplx Plus(cplx b);
	void NastavRe(double d) {re = d; }
	cplx(double r=0, double i=0);
	friend double Abs(cplx &c) {return sqrt(c.re * c.re + c.im*c.im);}
};

cplx::cplx(double r, double i)		// Konstruktor
: re(r), im(i) 				// inicializacni cast konstruktoru
{}

double cplx::Im() { return im; }	
double cplx::Re() { return re; }

/*
// Neprilis elegantni zpusob
// jak scitat komplexni cisla
cplx cplx::Plus(cplx b)
{
  cplx c;
  c.re = re + b.re;
  c.im = im + b.im;
  return c;
}
*/

cplx cplx::Plus(cplx b)			// Lepsi definice metody pro scitani
{
  return cplx(re+b.re, im+b.im);
}

void main()
{
	cplx C(1,1), D, E(1,5);		// Deklarace instanci znamena volani konstruktoru
    double d = Abs(C);
	D = C.Plus(E);
	C.NastavRe(11.3);
}