// Soubor SEZNAM1.CPP
// Jednosmerny seznam se zarazkou (priklad vnorene tridy a statickych slozek)
// neuplna implementace, obsahuje pouze:
// * deklaraci typu seznam::prvek (vnorene tridy) - pristup k datum pomoci referencnich funkci
// * konstruktor, ktery vytvori prazdny seznam (obsahujici pouze zarazku, tedy pomocny prazdny prvek)
// * destruktor, ktery uvolni vsechny prvky v seznamu
// * metodu VlozNaKonec, ktera vytvori novy prvek se zadanymi daty a vlozi ho na konec seznamu
// 
// Celkovy pocet seznamu ukazuje soukroma staticka datova slozka pocet
// jeji hodnotu, tedy celkovy pocet instanci, vraci verejna staticka metoda Pocet()

#include <iostream.h>

// Smesny zpusob osetrovani chyb
void Chyba() { cout << "CHYBA!!!" << endl; }

typedef int data;  // Typ vkladanych prvku

class seznam {
public:
	class prvek {			// Vnorena trida: prvek seznamu
		data _Data;
		prvek* _dalsi;
	public:
		prvek(data D=0);
		prvek* &Dalsi() {return _dalsi;}
		data & Data() {return _Data;}
	};
	seznam();
	~seznam();
	void VlozNaKonec(data D);
	static int Pocet() {return pocet; }
private:
	prvek *hlava, *zarazka;
	static int pocet; 		// Staticky atribut: celkovy pocet seznamu
};

int seznam::pocet = 0;	// Definicni deklarace staticke slozky

void seznam::VlozNaKonec(data D)
{
	prvek *p = new prvek(0); // Alokujeme novy prvek
	zarazka->Data() = D; // Ulozime data do zarazky
	zarazka->Dalsi() = p; // a pripojime novy prvek 
	zarazka = p;		// na konec jako novou zarazku
}

seznam::seznam()
{
	pocet++;  // Jeden seznam vytvoren - uprav celkovy pocet seznamu
	hlava = new prvek(0);
	zarazka = hlava;
}

seznam::~seznam()
{
	while (hlava != zarazka) // Vymaz vsechny smysluplne prvky
	{
		prvek *p = hlava;
		hlava = p->Dalsi();
		delete p;
	}
	delete hlava; // a nakonec vymaz i zarazku
	pocet--;      // Jeden seznam zrusen - uprav celkovy pocet seznamu
}

seznam::prvek::prvek(data D)
: _Data(D), _dalsi(0)
{ }

void main()
{
  seznam *S = new seznam;
  if(seznam::Pocet() == 0) Chyba();	// Pouziti staticke metody
  for(int i = 1; i < 5; i++) S ->VlozNaKonec (i);
  delete S;
}