/*
	Soubor GO.H
	Deklarace tridy GO (spolecny predek vsech grafickych objektu) 
	a jeho potomku Bod a Usecka
	- Aby spravne fungovalo ukladani do souboru pomoci operatoru <<,
	  musi kazda z nich obsahovat virtualni metodou Uloz(Soubor& s), ktera 
	  ulozi aktualni instanci do s.
	- Abychom se nemuseli starat o implementacni detaily grafickych objektu,
	  vypisuji metody Nakresli() a Smaz() pouze zpravy Kreslim bod..., 
	  Mazu bod... apod.
*/

#ifndef _GO_H_
 #define _GO_H_

//#include "soubor.h"

class Soubor;

class GO
{
protected:
 int barva;		// Slozka barva je chranena, aby s ni mohly
public:			// snadno pracovat i odvozene tridy
 GO(int bar): barva(bar){}
 virtual void Nakresli()=0;
 virtual void Smaz()=0;
 virtual Soubor& Uloz(Soubor&);	// Tato metoda bude mit na starosti skutecne ulozeni instance do souboru
 virtual~GO(){ }
};

class Bod: public GO
{
protected:
  int x, y;
public:
  Bod(int bar, int xx, int yy): GO(bar), x(xx), y(yy) {}
  void Nakresli();
  void Smaz();
  Soubor& Uloz(Soubor& s);
  ~Bod(){ Smaz(); }
};

class Usecka: public GO
{
protected:
  int x1,y1,x2,y2;
public:
  Usecka(int bar, int xx1, int yy1, int xx2, int yy2)
  : GO(bar), x1(xx1), y1(yy1), x2(xx2), y2(yy2) {}
  void Nakresli();
  void Smaz();
  Soubor& Uloz(Soubor& s);
  ~Usecka(){ Smaz(); }
};


#endif