// Soubor HLAVNI.CPP
/* Program predvadi "polymorfizmus operatoru vzhledem k pravemu operandu".
   Projekt (ktery si musite vytvorit sami, nebot zavisi na prostredi, ktere 
   pouzivate) se sklada se z techto souboru:
   - HLAVNI.CPP - hlavni program, ve kterem se predvadene konstrukce pouziji,
   - GO.H a GO.CPP, ktere obsahuji definici grafickych objektu (tridy GO, 
	 Bod, Usecka)
   - SOUBOR.H a SOUBOR.CPP, ktere obsahuji definici tridy Soubor pro binarni
     ukladani grafickych objektu pomoci operatoru << 
   
   Tento program obsahuje pole g ukazatelu na graficke objekty (typ GO*),
   do ktereho ulozi adresy dvou dynamickych instanci (Bod a Usecka).
   Tyto instance pak ulozi do instance tridy Soubor pomoci operatoru <<.
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "soubor.h"
#include "go.h"

const N = 2;

void main()
{
 Soubor s("data.dta");
 GO *g[N];
 g[0] = new Bod(1,2,3);
 g[1] = new Usecka(0xa, 0xb, 0xc, 0xd, 0xe);
 int i;
 for(i = 0; i < N; i++) g[i] -> Nakresli();
 s.Otevri(Soubor::zapis);
 for(i = 0; i < N; i++) s << *g[i];
 for(i = 0; i < N; i++) delete g[i];
 s.Zavri();
}