/* Soubor SOUBOR.H
	Definice typu Soubor, ktery zapouzdruje binarni soubor pro ukladani 
	grafickych objektu. Vyuziva prostredky prevzate z jazyka C (patri 
	ke 4. kapitole a zde jsme jeste neprobirali objektove datove proudy).

    - Metoda operator<<(GO&) je univerzalni, slouzi k ulkladani typu GO a 
	  vsech jeho potomku (presneji pouze tech potomku, nebot typ GO je 
	  abstraktni). Vola metodu virtualni Uloz() ukladaneho 
	  grafickeho objektu.

    - Metoda operator<<(int) je pomocna, slouzi k ukladani slozek grafickych 
	  objektu, ktere jsou vsechny celociselne.

*/

#ifndef _SOUBOR_H_
 #define _SOUBOR_H_

#include <stdio.h>

class GO;

void chyba(char* co);

class Soubor {
  FILE* f;
  char jmeno[100];	// Jmeno souboru
  // Nasledujici dve deklarace zabrani kopirovani instanci
  // Odpovidajici metody nedefinujeme
  Soubor& operator=(Soubor&);
  Soubor(Soubor&);
public:
  Soubor& operator<<(int i);	// Zapis celych cisel
  enum zpusob {cteni, zapis, pripisovani}; // Zpusob otevreni souboru
  Soubor(char* jm);
  int Otevri(zpusob);
  void Zavri();

  Soubor& operator<<(GO&);		// Zapis typu GO a jeho potomku
};
#endif