// Soubor CPLX2.CPP
// Pretezovani operatoru pro tridu cplx - komplexni cisla
// Chcete=li tento soubor prekladat na nekterem ze starsich prekladacu, odstrante komentar 
// u nasledujiciho prikazu:
// typedef int bool;

// UNARNI OPERATORY
// Operator minus (unarni): vrati kopii instance s obracenymi znamenky slozek
//    Je zde dvakrat, jednou jako metoda (uzavrena do komentare), podruhe jako 
//    spratelena funkce - obe funguji, v programu smi byt ale jen jedna
// Operator + (unarni): vrati aktualni instanci beze zmeny
// Operator !: vrati true, je-li re == 0 a zaroven im == 0, jinak vrati false

// BINARNI OPERATORY
// Operator + (scitani)
// Operator * nasobeni


#include <math.h>
class cplx {
public:
	cplx(double r=0, double i=0): re(r), im(i) {}
	double Re() { return re; }
	double Im() { return im; }
	friend double Abs(cplx& c) {return sqrt(c.re*c.re + c.im*c.im);}

	// UNARNI OPERATORY
	// Operator unarni minus (otoci znamenka obou slozek)
	// jako metoda bez parametru
	//cplx operator-() { return cplx(-re, -im); }

	// Jina moznost: spratelena funkce s jednim parametrem
	friend cplx operator-(cplx& c);
	
	bool operator!() { return !re && !im; }
	cplx operator+() { return *this; }

	// BINARNI OPERATORY
	// Scitani jako metoda: fungije, ale ma sve problemy (viz kniha), pouzijeme radeji
	// spratelenou funkci
	// cplx operator+(cplx b) { return cplx(re+b.re, im+b.im);}
	friend cplx operator+(cplx a, cplx b);
	friend cplx operator*(cplx a, cplx b);
private:
	double re, im;
};

// Jina moznost, jak deklarovat unarni minus pro komplexni cisla
cplx operator-(cplx& c)
{
	return cplx(-c.re, -c.im);
}

// Jina moznost, jak deklarovat scitani pro komplexni cisla


cplx operator*(cplx a, cplx b)
{
  return cplx(a.re*b.re - a.im*b.im, a.re*b.im+a.im*b.re);
}


cplx operator+(cplx a, cplx b)
{
	return cplx(a.re+b.re, a.im+b.im);
}

/*
// Znovu operator scitani, pochybna implementace
//NEFUNGUJE VE SLOZITEJSICH VYRAZECH - NENI REENTRANTNI
cplx& operator+(cplx &a, cplx &b)
{
	static cplx pom;
	pom = cplx(a.re+b.re, a.im+b.im);
	return pom;
}
*/

void main()
{
	cplx a(1,1), b, i(0,1), j(1,0);
	b = -a;		// Vola se cplx::operator -()
	bool c = !a;
	c = !cplx(0,1);
	b = a+i;
	//b = a + 5;
	b = (a+j)*(i+j);
}
