// Soubor NEW2.CPP
// Operator new pretizeny jako metoda
//
// Typ strela predstavuje strelu v nejake pocitacove hre.
// Strel je mnoho, ale ziji jen kratce, proto se nechceme zatezovat jejich
// alokaci z volne pameti a naslednym uvolnovanim. Strely alokujeme v arene, poli
// o dostatecne velikosti, ve kterem se ukladaji jedna za druhou a 
// po vycerpani kapacitu areny zase od pocatku. Pritom doufame, ze strely, 
// ktere takto prepiseme, uz davno neexistuji. K tomu si definujeme zvlastni operator new
// jako metodu typu strela.

#include <iostream.h>
#include <stddef.h>

class strela {
	enum {pocet = 1000};	// Maximalni pocet strel
	double x, y, rychlost;

	static char arena[];	// Pole pro alokaci strel
	static int index;		// Prubezny index pro alokaci strel
	static const int velikost; // Velikost 1 strely v bajtech
public:
	strela(double xx=0, double yy=0, double rr=0)	// Konstruktor
		:x(xx), y(yy), rychlost(rr){}	
	void let();
	void * operator new(size_t s);					// Operator new, ktery alokuje strely do areny
	void * operator new[](size_t s);				// Polni verze operatoru new
};

void *strela::operator new(size_t s)
{
	int i = index;
	index += s;
	if(index < pocet*velikost)
		return &arena[i];
	else if(index == pocet*velikost)
	{
		index = 0;
		return &arena[i];
	}
	else
	{
		index = 0;
		return arena;
	}
}

char strela::arena[pocet*sizeof(strela)];		// Deklarace statickych slozek
int strela::index = 0;
const int strela::velikost = sizeof(strela);

void * strela::operator new[](size_t s)
{
	return operator new(s);
}

void main()
{
	for(int i = 0; i < 10; i++)					// Priklad pouziti
	{
		strela* u = new strela;
		cout << u << endl;
	}
}