// Soubor PRETYP.CPP
// Operator pretypovani

// Trida string reprezentujici znakovy retezec obsahuje pole znaku 
// Konstruktor do tohoto pole ulozi retezec
// Operator pretypovani na const char* vrati ukazatel na toto pole
// s je instance tridy string
// V prikazu strcpy(ccc, s) se s automaticky konvertuje na const char*
//
#include <string.h>
#include <iostream.h>

class string {
public: 
	enum {delka = 10};
	string(const char* = 0);
	operator const char * ();
private:
	char c[delka+1];	// Navic 1 znak pro koncovou 0
};

string::string(const char* C)
{
	for(int i = 0; i < delka+1; i++) c[i] = 0;
	if(C) {
		int n = strlen(C);
		strncpy(c, C, (n>delka?delka:n));
	}
}

string::operator const char *()
{
	return c;
}

void main(){
  string s("Ahoj lidi tam");
  cout << s << endl;	// Vypise "Ahoj lidi "
  char ccc[20];
  strcpy(ccc, s);	// Zde se automaticky pouzije nas operator pretypovani 
  // char *c = s; // CHYBA - nelze priradit ukazatel na konstantu ukazateli na nekonstantni objekt
  //strcpy(s, ccc); // CHYBA - s nelze konvertovat na char*
  char d = s[1];
  // s[1] = 'u';// CHYBA - chceme menit konstantni objekt
}