// Soubor T_SPECX.CPP
// Priklad na specializaci sablon
// Prelozeno v Borland C++ Builderu 4.0
// Sablona pole s parametrem typu T obsahuje zapouzdrene pole typu T
//
// Prvni specializace pro ukazatele implementuje jinak konstruktor a
// obsahuje navic operator =
//
// Druha specializace pro typ void* je vlastne
// stejna jako primarni sablona


#pragma hdrstop
#include <condefs.h>
const int n = 5;

template<typename T>     // Primarni sablona
class pole
{
        T p[n];
public:
        pole(){for( int i = 0; i < n; i++) p[i] = 0;}
        T& operator[] (int i) { return p[i];}
};

template<typename T>    // Specializace pro ukazatele
class pole<T*>
{
        T* p[n];
public:
        pole(){for( int i = 0; i < n; i++) p[i] = new T(0);}
        pole& operator=(pole& q)
        {
         for(int i = 0; i < n; i++)
                *p[i] = *q.p[i];
        }
        T& operator[](int i) { return *p[i];}
};

template<>                     // Specializace pro typ void*s
class pole<void*>
{
        void* p[n];
public:
        pole(){for( int i = 0; i < n; i++) p[i] = 0;}
        void*& operator[](int i) { return p[i];}
};


#pragma argsused
int main(int argc, char* argv[])
{
  pole<int> Pint, Qint;
  for(int i = 0; i < 3; i++) Pint[i] = 0;
  Qint = Pint;

  pole<int*> Pui, Qui;
  for(int i = 0; i < 3; i++) Pui[i] = 0;
  Qui = Pui;

  pole<void*> P;
  for(int i = 0; i < 3; i++) P[i] = 0;
  pole<void*> Q;
  Q = P;
}
