// Soubor VYJIMKA1.CPP
// Prvni priklad pouziti vyjimek
//
// Trida A ma konstruktor a destruktor, ktere vypisuji hlaseni,
// To je jejich jediny ucel.
//
// Funkce f vyvola vyjimku, je-li parametr roven 1.
//
// Ve funkci main v pokusnem bloku nejprve deklarujeme 
// instanci a tridy A, pak v cyklu volame funkci f.
//
// Beh programu vypada takto:
// - Po vstupu do pokusneho bloku (blok try) se vytvori instance y tridy A
//   a konstruktor o tom vypise zpravu.
// - Pak zacne cyklus for. Pri prvnim pruchodu se zavola funkce f(0),
//   v ni se vytvori instance x tridy A, otestuje se podminka, ta neni splnena,
//   vypise se hlaseni,
//   instance x zanikne (destruktor o tom vypise zpravu) a program se vrati z f.
// - Pak se zavola f(1). Vytvori se instance x tridy A a probehne prikaz throw, nebot 
//   je splnena podminka i == 1. Zavola se destruktor instance x a program odejde z f.
//   Hlaseni se nevypise, nebot prikazy od mista, kde vznikla vyjimka, do konce bloku se preskoci.
// - Vyjimka se rozsiri do funkce main. Zbytek pokusneho bloku se jiz neprovede, to znamena, ze 
//   iterace cyklu for pro i == 3, ..., 10 a nasledujici vystup neprobehnou.
// - Program prejde do handleru a pak pokracuje za nim.
//
// ZA TEXTEM PROGRAMU NASLEDUJE VYSATUP PROGRAMU A NAVOD K NEKOLIKA EXPERIMENTUM
//

#include <iostream>
#include <exception>

using namespace std;

class A
{
	int i;
public: 
	A(int a): i(a){cout << "konstruktor A " << i << endl;}
	~A(){cout << "destruktor A " << i << endl;}
};

void f(int i)
{
	A x(i);
	if (i == 1) throw logic_error("POMOC!!! i == 2");
	cout << "funkce f, i == " << i << endl;
}


void main()
{
	try {
		A y(99);
		for(int i = 0; i < 10; i++) f(i);
		cout << "jsme zde" << endl;
	}
	catch(logic_error e)
	{
		cout << "logicka chyba: " << e.what() << endl;
	}
	cout << "Pokracujeme za vyjimkou" << endl;
}

/***********************************************
Vystup tohoto programu je (komentare k nemu nepatri)

konstruktor A 99	// Konstrukce y
konstruktor A 0		// Konstrukce x pri prvnim vstupu do f
funkce f, i == 0	// Za mistem, kde muze vzniknout vyjimka ve funkci f
destruktor A 0		// Zanik instance x pri vystupu z f
konstruktor A 1		// Konstrukce x pri druhem vstupu do f
destruktor A 1		// Zanik x po vzniku vyjimky
destruktor A 99		// Zanik y po rozsireni vyjimky do pokusneho bloku
Vyjimka: POMOC!!! i == 2// V handleru
Pokracujeme za vyjimkou	// Program pokracuje za handlerem


Namety k pokusum:
1. Zmente typ vyjimky v handleru na exception. Vystup programu (a jeho beh) se nezmeni.
2. Zmente podminku ve funkci f tak, aby k vyjimce nedoslo.
3. Za blok try pripojte misto stavajiciho tyto dva handlery :
	catch(logic_error e)
	{
		cout << "logicka chyba: " << e.what() << endl;
	}
	catch(exception e)
	{
		cout << "Obecna vyjimka: " << e.what() << endl;
	}
   Zkuste, jak to dopadne, jestlize funkce f vyvola vyjimku 
   logic_error, exeption nebo runtime_error.
   (V poslednim pripade program skonci chybovym hlasenim 
   "Abnormal program termination" nebo podobnym.
4. Za blok try pripojte tytez handlery v opacnem poradi:
	catch(exception e)
	{
		cout << "Obecna vyjimka: " << e.what() << endl;
	}
	catch(logic_error e)
	{
		cout << "logicka chyba: " << e.what() << endl;
	}
   Prekladac nejspis vypise varovani, ale program prelozi. Ovsem at 
   vznikne ve funkci f vyjimka logic_error, exeption nebo runtime_error,
   zachyti ji prvni handler (s parametrem typu exception).
*/