// Soubor CCAST1.CPP
// priklad na pouziti operatoru const_cast
//
// Deklarujeme tridu D, ktera obsahuje metodu hodnota, a to jak 
// variantu pro konstantni instance, tak variantu pro nekonstantni instance.
// (To C++ dovoluje.)
// Operator const_cast pouzijeme k tomu, abychom pro nekonstantni instanci zavolali
// metodu urcenou pro konstantni instance
//

#include <iostream>
using namespace std;

class D {
	int d;
public:
	D(int d): d(d){}
	int hodnota() const {
		cout << "Vola se metoda pro konstantni instance" << endl;
		return d;
	}
	int hodnota() {
		cout << "Vola se metoda pro nekonstantni instance" << endl;
		return d;
	}
};

void main()
{
	const D d1(5);
	D d2(6);
	d1.hodnota();					// Zavola se metoda hodnota() const;
	const_cast<D&>(d1).hodnota();	// Zavola se metoda hodnota();
	d2.hodnota();					// Zavola se metoda hodnota();
	const_cast<const D&>(d2).hodnota();// Zavola se metoda hodnota() const;
}