// Soubor RCAST1.CPP
// priklad na pouziti operatoru reinterpret_cast
// deklarovane tridy jsou stejne jako v souboru DCAST1.CPP
//
#include <typeinfo>					// Viz soubor DCAST.CPP na WWW
#include <iostream>
using namespace std;
class A {									// Predek
	int a;
public:
	A(int i): a(i){}
	virtual ~A() {}						// Potrebujeme virtualni metodu
	int hodnota() { return a; }
};
class B {									// Dalsi, nezavisly predek
	int b;
public:
	B(int i): b(i){}
	virtual ~B() {}
	int hodnota() { return b; }
};
// C je spolecnym (jednoznacnym a pristupnym) potomkem A a B
class C: public A, public B
{
	int c;
public: 
	C(int c): A(c), B(c+1), c(c+2) {}
	int hodnota() { return c; }
};
A a(1); 					// Instance
B b(2);
C c(3); 					// c.a == 3, c.b == 4, c.c == 5
A* ua;						// Ukazatele na instance
B* ub;
C* uc = &c; 

void f(B& b)				// Funkce f ocekava parametr typu B
{
	cout << b.hodnota(); 
}

void main()
{
	ua = &a;

// Jina interpretace ukazatele
	ub = reinterpret_cast<B*>(ua);	// Ukazatel na a interpretovany jako ukazatel na instanci tridy B
	cout << ub ->hodnota() << endl;	// Vypise 1, nebot tridy A a B maji NASTESTI STEJNOU VNITRNI STRUKTURU

// Pretypovani instance
	f(reinterpret_cast<B&>(a));		// A a B maji stejnou strukturu, takze se muzeme predat A 
									// na miste, kde se ocekava B, pokud ho pretypujeme
}									// Vypise opet 1