// Soubor RTTI1.CPP
// Priklad ukazujici dynamickou identifikaci typu a jeji pouziti
// pro polymorfni typy, kdy opravdu funguje, 
// a pro nepolymorfni typy, kdy vlastne nefunguje
//
// !!! POZOR: V NEKTERYCH PREKLADACICH JE NUTNO RTTI PREDEM POVOLIT !!!
// !!! V NASTAVENICH PREPINACU PREKLADACE, JINAK PROGRAM NEFUNGUJE  !!!
//
// V teto podobe obsahuje program dve polymorfni tridy, Alfa a Beta, 
// ktere obsahuji virtualni metodu f. Trida Beta je potomkem Alfa.
// V hlavnim programu jsou deklarovany ukazatele p1 a p2 na typ Alfa, 
// Ukazateli p1 je prirazena adresa instance typu Alfa, 
// ukazateli p2 prirazena adresa instance typu Beta.
// V bloku try nejprve vypiseme typ instance, na ktery p2 ukazuje,
// pomoci metody name(). Program spravne vypise, ze p2 ukazuje na 
// instanci typu Beta. (Tridy jsou polymorfni, RTTI opravdu funguje.)
//
// Pak zmenime direktivu 
// #define VIRTUAL virtual
// na 
// #define VIRTUAL
// a tim zmenime polymorfni tridy na nepolymorfni. RTTI jiz nebude fungovat 
// spravne, prikaz b bloku try vypise, ze p2 ukazuje na instanci typu Alfa.

#include <typeinfo>
#include <iostream>
using namespace std;
 
#define VIRTUAL virtual		// Zmenou teto direktivy se z polymorfnich trid stanou nepolymorfni
class Alfa {
public:
 	VIRTUAL void f() {cout <<"Alfa"<<endl;};
};
class Beta:public Alfa {
public:
 	void f(){ cout << "Beta" << endl;};
};
int main(){
	Alfa p;
	Beta d;
	Alfa *p1= &p, *p2 = &d;
	try{
		cout 	<< "p2 ukazuje na objekt typu "<< typeid(*p2).name() 
					<< endl
					<< 	(typeid(*p1).before(typeid(*p2)) ?
							"Prvni v abecede je objekt, na ktery ukazuje p1" :
							"Prvni v abecede je objekt, na ktery ukazuje p2" ) << endl;
	}
	catch(bad_typeid){
		cout << "Dereferencujes 0" << endl;
		return 1;
	}
	return 0;
}

/*
VYSTUP TOHOTO PROGRAMU V DANE PODOBE:
p2 ukazuje na objekt typu class Beta
Prvni v abecede je objekt, na ktery ukazuje p1

VYSTUP TOHOTO PROGRAMU PO ZMENE POLYMORFNICH TRID NA NEPOLYMORFNI
p2 ukazuje na objekt typu class Alfa
Prvni v abecede je objekt, na ktery ukazuje p2
*/