// Soubor SCAST1.CPP
// Priklady ukazujici fungovani operatoru static_cast
//
// Nejprve tridy, na kterych to budeme predvadet 

#include <iostream>
using namespace std;

class A {					// trida A obsahuje konverzni metodu operator int()
	int a;
public:
	A(int i): a(i){}
	virtual ~A() {}
	int hodnota() { return a; }
	operator int&() {return a;}
};

class B {
	int b;
public:
	B(int i): b(i){}
	virtual ~B() {}
	int hodnota() { return b; }
};

enum dny {po, ut, st, ct, pa, so, ne};

// C je spolecnym (jednoznacnym a pristupnym) potomkem A a B

class C: public A, public B
{
	int c;
public: 
	C(int c): A(c), B(c+1), c(c+2) {}
	int hodnota() { return c; }
};

A a(1); // Instance
B b(2);
C c(3);
A* ua;	// Ukazatele na instance
B* ub;
C* uc = &c;

void main()
{
// static_cast a bezna pretypovani neobjektovych typu
	double d = 55.2;
	dny dn;
	int i;

	i = static_cast<int>(d);	// Pretypovani, ktere muze probehnout automaticky
	dn = static_cast<dny>(2);	// Pretypovani na vyctovy typ

// static_cast zavola konverzni funkci
	int &rint = static_cast<int&>(a);	// totez jako int& rint = (int&)a;
	rint = 33;							// Prirazeni do slozky a.a
	cout << a.hodnota() << endl;		// Vypise 33

	int j = static_cast<int>(a);		// Opet se pouzije konverzni operator

// Konverze objektovych typu a ukazatelu na ne

// Pretypovani na predka
	ua = static_cast<A*>(uc);	// Pretypovani na predka: dovolene, i kdyz zbytecne
	ua = uc;					// Znamena naprosto totez co predchozi prikaz 
								// nebo ua = (A*)uc;
								// nebo ua = static_cast<A*>(uc);

	i = ((A&)c).hodnota();				// Totez co nasledujici prikaz
	i = static_cast<A&>(c).hodnota();		// Totez
	i = c.A::hodnota();						// Totez bez pretypovani


// Pretypovani na potomka
	ub = uc;								// ub ukazuje na zdedeny podobjekt typu B v c

	C* ucc = static_cast<C*>(ub);			// Konverze na ukazatel na potomka ramci hierarchie 
	cout << ucc -> hodnota() << endl;		// Vypise 5

	ub = &b;								// ub ukazuje na samostatnou instanci

	ucc = static_cast<C*>(ub);				// Pretypovani nema smysl,ub obsahuje adresu samostatne instance tridy B
	cout << ucc -> hodnota() << endl;		// Vypise nejaky nesmysl

// Totez pro reference
	B &rb = c;								// rb je odkaz na zdedeny podobjekt tridy B v instanci c
	cout << rb.hodnota() << endl;			// Vypise 4
	
	cout << static_cast<C&>(rb).hodnota() << endl;	// Vypise 5, nebot rb je reference na zdedeny podobjekt v instanci typu C
	cout << static_cast<C&>(b).hodnota() << endl;	// Vypise nejaky nesmysl, nebot pretypovani nema smysl

// Pretypovani na z predka na jineho nezavisleho predka

	ub = uc;								// ub ukazuje na zdedeny podobjekt typu B v c
	//ua = static_cast<A*>(ub);				// Chyba: tohle static_cast neumi
	ua = static_cast<A*>(static_cast<C*>(ub));	// Takhle to jde obejit, ale bez dynamicke kontroly typu  
	cout << ua->hodnota() << endl;			// Vypise 3
}