// Soubor NSP4.CPP
// Priklad vyhledavani operatoru v prostorech jmen
//
// Program obsahuje dva prostory jmen Complex a Real
// V prvnim je deklarovana trida Cplx vyjadrujici komplexni cisla a
// operator pro ccitani dvou komplexnich cisel,
// ve druhem trida Double zapouzdrujici typ double
// a operator pro scitani typu Cplx a Double (v tomto poradi)
//
// Ve funkci main() je deklarovano nekolik instanci a vypocteny soucty
// Cplx + Cplx a Cplx + Double.
// Oba prekladac zvladne, nebot operatory jsou deklarovany 
// v prostorech jmen operandu

// Protoze deklarace operatoru na sobe zavisi, deklarujeme nejprve 
// prostory jmen a predbezne deklarace trid a operatoru

namespace Complex { class Cplx; Cplx operator+(Cplx, Cplx); }
namespace Real{ class Double; Complex::Cplx operator+(Complex::Cplx, Double); }

// Komplexni cisla
namespace Complex {
	class Cplx {
		double re, im;
	public:
		Cplx(double _re = 0, double _im = 0): re(_re), im(_im){}
		friend Cplx operator +(Cplx, Cplx);
		friend Cplx Real::operator+(Complex::Cplx, Double);
	};

	Cplx operator +(Cplx a, Cplx b)
	{
		return Cplx(a.re+b.re, a.im+b.im);
	}
}


// Realna cisla
namespace Real {
	class Double {
		double d;
	public:
		Double(double _d): d(_d){}
		friend Complex::Cplx operator + (Complex::Cplx c, Double d)
		{
			return Complex::Cplx(d.d+c.re, c.im);
		}
	};

}

// Pouziti obou operatoru: jsou deklarovany v kontextu operandu
void main()
{
	Complex::Cplx a(2,3), b(5,8), c;
	Real::Double d(5);
	c = a+b;	// Operator bude nalezen v prostoru Complex
	c = c+d;	// Operator bude nalezen v prostoru Real
}

