// Soubor IO1.CPP
// Priklad formatovani pri vystupu
//
// Funkce Tab vytiskne tabulku matematicke funkce f. Nazev funkce
// (pro tisk) je obsazen v parametru s.
// Funkce ukazuje pouziti manipulatoru setw(n), ktery nastavuje sirku 
// vystupniho pole, 
// manipulatoru fixed, ktery predepisuje format s pevnou radovou carkou,
// manipulatoru setprecision(n), ktery predepisuje pocet desetinnych mist
// (je-li dan format fixed),
// a manipulatoru showpoint, ktery predepisuje zobrazovat desetinnou tecku vzdy.
//
// Pozor: zatimco vetsina nastaveni pomoci manipulatoru plati od chvile 
// nastaveni do chvile, kdy je nejak zrusime
// nastaveni sirky pole pomoci setw(n) plati vzdy jen pro nasledujici vystup.

// Doporucuji zkusit menit nebo odstranovat manipulatory
// a pozorovat, co to dela

#include <iomanip>
#include <iostream>
#include <math.h>

using namespace std;

void Tab(const char* s, double (*f)(double))
{
	cout << "Tabulka funkce " << s << endl;
	cout << "-------------------" << endl;
	cout << setw(5) << "x" << setw(8) << s << "(x)" << endl;
	cout << "-------------------" << endl;
	cout << setprecision(5) << fixed << showpoint;
	for(int i = 0; i <= 10; i++)
	{
		double x = i/10.0;
		cout << setw(5) << x << setw(10) << f(x) << endl;
	}

}

void main()
{
	Tab("sin", sin);
}

/*
  VYZNAM MANIPULATORU:
  setw(n): kolik znaku ma nasledujici vystup zabirat.
  fixed: format s pevnou radovou teckou vzdy.
  setprecision: Je-li nastaveno fixed, je to pocet desetinnych mist, jinak celkovy pocet
  platnych cifer.
  endl: okamzite vypis pripraveny vystup a prejdi na novou radku.
  showpoint: zobrazuj desetinnou tecku, i kdyz je zbutecna.
*/