// Soubor IO2.CPP
// Proud jako parametr, vystup do souboru
//
// Funkce Tab je stejna jako v souboru IO1.CPP, az na to,
// ze jejim prvnim parametrem je odkaz na instanci typu ostream
// To umoznuje predat jako skutecny parametr libovolny vystupni proud
//
// Vystup do souboru: ve funkci main() definujeme instanci F typu fstream
// (souborovy proud pro vstup i vystup).
// Prvni parametr konstruktoru je jmeno souboru, 
// druhy parametr je rezim otevreni - urcuje ho vyctovy typ, 
// definovany ve tride ios. Hodnota ios::out predepisuje otevreni pro vystup.
// (Priznaky tohoto vyctoveho typu lze spojovat pomoci operatoru |.)
// Tento konstruktor automaticky proud take otevre.
//
// Pomoci pretizeneho operatoru ! testujeme, zda se otevreni podarilo.
// Pokud ne, volame funkci Chyba().
// Po navratu z funkce Tab() proud uzavreme pomoci metody close. (Zde to je zbytecne, 
// o uzavreni by se tak jako tak postaral destruktor.
// Ostatni zachazeni s proudem F je stejne jako v pripade proudu cout. 

#include <iomanip>
#include <iostream>
#include <fstream>
#include <math.h>
#include <stdlib.h>

using namespace std;

void Chyba(){ // Primitivni osetreni chyby: hlaseni a konec programu
	cerr << "Nejde otevrit soubor" << endl;
	exit(0);
}

void Tab(ostream& Proud, const char* s, double (*f)(double))
{
	Proud << "Tabulka funkce " << s << endl;
	Proud << "-------------------" << endl;
	Proud << setw(5) << "x" << setw(8) << s << "(x)" << endl;
	Proud << "-------------------" << endl;
	Proud << setprecision(5) << fixed << showpoint;
	for(int i = 0; i <= 10; i++)
	{
		double x = i/10.0;
		Proud << setw(5) << x << setw(10) << f(x) << endl;
	}

}

void main()
{
	fstream F("data.dta", ios_base::out);	// Vytvor proud a otevri soubor
	if(!F)									// Pokud se to nepodari, volej chybovou funkci
	  Chyba();
	
	Tab(F, "sin", sin);						// Proud jako parametr funkce

	F.close();	// Zde zbytecne, udelal by to automaticky volany destruktor
}

