// Soubor IO5.CPP
// Priklad aktualizace souboru
// Funkce VytvorSoubor() vytvori binarni soubor data.dta obsahujici cela cisla 0 .. 9
// Funkce VypisSoubor() vypise zadany soubor celych cisel na obrazovku
//
// Funkce Aktualizuj() projde zadany soubor, vyhleda v nem suda cisla a nahradi je polovicni hodnotou
// - nejprve vytvori vstupne-vystupni proud F,
// - pak v cyklu vzdy precte jeden zaznam do promenne i,
// - je-li to sude cislo, vydeli ho dvema,
// - pomoci tellg() zjisti aktualni vstupni pozici a nastavi aktualni vystupni pozici o sizeof(i) mensi
// - zapise i pomoci metody write().

#include <fstream>
#include <iostream>
#include <stdlib.h>

using namespace std;

const char * Jmeno = "data.dta";

void Chyba()
{
	cerr << "nepodarilo se otevrit soubor" << endl;
	exit(1);
}

void VytvorSoubor(const char* jmeno)
{
	ofstream F(jmeno);
	for(int i = 0; i < 10; i++)
		F.write((char*)&i, sizeof(i));
}

void VypisSoubor(const char* Jmeno)
{
	ifstream F(Jmeno);
	if(!F) Chyba();
	int i;
	while(F.read((char*)&i, sizeof(i)))
		cout << i << endl;

}

void Aktualizuj(const char *Jmeno)
{
  fstream F(Jmeno, ios::in | ios::out | ios::binary);// Vytvor proud pro vstup a vystup, binarni
  if(!F) Chyba();

  int i;				// Do i cteme
  while(F.read((char*)&i, sizeof(i)))	// Precti zaznam
  {
          //if(!F) Chyba();
          if(!(i & 1))			// Je-li cislo sude
          {
                  i /= 2;		// akyualizuj ho
                  F.seekp(F.tellg() -(long)sizeof(int), ios::beg); // Nastav pozici ve vystupu
                  F.write((char*)&i, sizeof(i));	// a zapis novou hodnotu
          }	// F.tellp();	// Tohle pozaduje Visual C++ 6.0, jinak v nem program nechodi	
  }
}

void main()
{
        VytvorSoubor(Jmeno);
	VypisSoubor(Jmeno);
        Aktualizuj(Jmeno);
	VypisSoubor(Jmeno);
}