// Soubor IO6.CPP
// Vystup do pametoveho proudu
//
// Ve funkci main() vytvorime proud ostringstream (konstruktor je bez parametru)
// a tento proud predame jako parametr funkci Tab()
// Funkce Tab() se nezmenila, je stejna jako v IO2.CPP
// Pos skonceni vystupu muzeme data z tohoto proudu ziskat
// napr. pomoci metody str(), ktera vrati instanci typu string
// tu lze napr. vypsat do standardniho vystupu pomoci operatoru <<

#include <iomanip>
#include <iostream>
#include <sstream>
#include <math.h>
#include <stdlib.h>

using namespace std;

void Chyba(){ // Primitivni osetreni chyby: hlaseni a konec programu
	cerr << "Nejde otevrit soubor" << endl;
	exit(0);
}

void Tab(ostream& Proud, const char* s, double (*f)(double))
{
	Proud << "Tabulka funkce " << s << endl;
	Proud << "-------------------" << endl;
	Proud << setw(5) << "x" << setw(8) << s << "(x)" << endl;
	Proud << "-------------------" << endl;
	Proud << setprecision(5) << fixed << showpoint;
	for(int i = 0; i <= 10; i++)
	{
		double x = i/10.0;
		Proud << setw(5) << x << setw(10) << f(x) << endl;
	}

}

void main()				// Viz soubor IO6.CPP na WWW
{
	ostringstream S;	// Vytvor proud a otevri soubor
	if(!S)					// Pokud se to nepodari, volej chybovou funkci
	  Chyba();
	
	Tab(S, "sin", sin);// Proud jako parametr funkce
	cout << S.str() << endl;
}

