// Soubor IO7.CPP
// Pouziti pametovych proudu pri analyze prikazove radky programu
//
// Program muze mit v prikazove radce prepinace -a, -r a -v v libovolnem poradi
// postup nanlyzy prikazove radky: 
// - pro kazdy z parametru (krome nulteho, kde je jmeno programu) vytvorime vstupni pametovy proud
// - Precteme z nej jeden znaku neni-li to '-', ignoruje se
// - Je-li to '-', precte se dalsi znak. Ten se pak porovna s polem symbols znaku prepinacu
//   a podle toho, kolikaty je, se nastavi odpovidajici hodnota v poli settings
//
// Nakonec program vytvori vystupni proud, v nem zformatuje retezec rikajici,
// jaka nastaveni program v prikazove radce nasel, a vypise je.

#include <sstream>
#include <iostream>

using namespace std;

const int N = 3;

bool settings[N] = {false,};		// Pole uchovavajici zadana nastaveni
char symbols[N] = {'a', 'r', 'v'};	// pole symbolu pro jednotliva nastaveni

void main(int argc, char** argv)
{
	for(int i = 1; i < argc; i++)
	{
		char c; 
		istringstream S(argv[i]);	// Vytvor proud pro i-ty parametr programu
		S >> c;				// Precti znak
		if(c != '-') break;		// neni-li to '-', jdi na dalsi
		S >> c;				// Precti dalsi znak
		for(int j = 0; j < N; j++)	// Vyhledej ho v poli symbols
			if(c == symbols[j])	// a az ho najdes, zapis do odpovidajiciho prvku pole 
			{			// settings hodnotu true
				settings[j] = true; 
				break; 
			}
	}
	// Vypis prectenych nastaveni
	ostringstream T;			// Vytvor vystupni proud, vloz bdo nej zakladni hlaseni
	T << "Pouzita nastaveni: ";		// a pripoj symboly zadanych nastaveni
	for(int j= 0; j < 3; j++)
		if(settings[j]) T << symbols[j];
	cout << T.str();			// Vypis obsah proudu na standardni vystup

}