// Soubor IO8.CPP
// Nejjednodussi uzivatelska definice operatoru >> a << pro vstup a vystup
//
// V programu je definovana trida cplx reprezentujici komplexni cisla.
// Operator << ma na starosti vystup komplexnich cisel ve tvaru (a, b),
// operator >> cte komplexni cislo jako dvojoci realnych cisel oddelenych mezerou
//
// Pozor: MS Visual C++ 6.0 tento program neprelozi, hlasi "nejednoznacne operatory"
// a "nedovoleny pristup k soukromym slozkam tridy cplx". (Deklaraci friend bere 
// jako deklaraci jine funkce nez jsou nasledujici deklarace operatoru)
// Jde zrejme o chybu prekladace.

#include <iostream>

using namespace std;

class cplx {
	double re;
	double im;
public:
	double Re(){ return re;};
	double Im(){ return im;};
	cplx(double re=0, double im=0):re(re), im(im){};
	friend ostream& operator<<(ostream& Proud, cplx& c);
	friend istream& operator>>(istream& Proud, cplx& c);
};

// Vstupni operator << MUSI mit prvni parametr typu istream& (predavany odkazem)
// a MUSI vracet predany proud odkazem.
istream& operator>>(istream& Proud, cplx& c)
{
	return  Proud >> c.re >> c.im;
}

// Vystupni operator >> MUSI mit prvni parametr typu ostream& (predavany odkazem)
// a MUSI vracet predany proud odkazem.
ostream& operator<<(ostream& Proud, cplx& c)
{
	return Proud << "(" << c.re << ", " << c.im << ")";
}

/*
// vylepsena verze operatoru <<
ostream& operator<<(ostream& Proud, cplx& c)
{
 int j = Proud.width();      // Zjistimne nastavenou sirku
 Proud << setw(0);           // implicitni sirka
 j = (j-4)/2;                // Rozpocitame sirku na obe slozky
 if (j<0) j = 0;
 return Proud << "(" << setw(j) << c.re << ", " << setw(j) << c.im << ")";
}
*/
void main()
{	// Nejake banalni pouziti...
	cplx c(1,2);
	cout << c << endl;
	cin >> c;
	cout << setw(10) << c;
	
}

