// Soubor STL02.CPP
// Ukazka pouziti funkcniho objektu pri trideni dvoustranne fronty.
//
// Program vytvori d - prazdnou dvoustrannou frontu (deque) pro cela cisla.
// Do d pak ulozi cisla 0, -1, 2, -3, ... -9 (cisla od 0 do 9 se stridavymi znamenky).
// K tomu pouzije metody d.push_back().
// Pak obsah d vypise. Protoze vime, kolik cisel ve fronte je, 
// mohli bychom pouzit operator indexovani. Bezpecnejsi je ale funkce at(),
// ktera v pripade, ze pouzijeme chybny index, vyvola vyjimku.
//
// Dale pouzijeme na d knihovni funkci sort(), ktere jako parametry predame
// iteratory d.begin() a d.end(), ktere ukazuji NA prvni a ZA posledni prvek.
// Vysledek vypiseme.
//
// Pak na d pouzijeme jeste jednou sort(), ktere ale jako treti parametr
// predame instanci tridy Comp. Tato trida zapouzdruje operator <
// (nebo presneji relaci a < b).
// Ve skutecnosti neobsahuje nic jineho nez pretizeny operator volani
// funkce se dvema parametry a vraci true, resp. false podle toho,
// zda je prvni parametr mensi nebo vetsi nez druhy.
// UPRAVAMI TRIDY Less MUZEME SNADNO MENIT KRITERIUM TRIDENI.
//
// Vysledek opet vypiseme.
//
// Zkuste si ruzne menit metodu Comp::operator()() a tim menit kriterium trideni.

#include <deque>
#include <iostream>
#include <algorithm>
#include  <stdlib.h>
#include <conio.h>

using namespace std;

class Comp	// Trida zapouzdrujici operator relaci "a < b"
{
  public: bool operator()(int a, int b)
  {
       return abs(a) > abs(b);
  }
};

// Vypis fronty v zadanem rozmezi indexu
void vypis(deque<int>& D, int I, int J)
{
 try {
     for(int i = I; i < J; i++)
         cout << D.at(i) << " ";
     cout << endl;
 }
 catch(...) {}
}

void main()
{
 deque<int> d;		// Vytvor prazdnou frontu
 for(int i = 0, j = 1;	// vypln ji cisly 0, -1, 2, -3, 4, -5...
         i < 10;
	 i++, j = -j)
         d.push_back(i*j);

 vypis(d, 0, 10);  // Vypis prvnich 10 prvku fronty

 sort(d.begin(), d.end());	// Utrid pomoci standardniho porovnani

 vypis(d, 0, 10);

 sort(d.begin(), d.end(), Comp()); // Utrid podle pomoci Comp

 vypis(d, 0, 10);

 getch(); // Kvuli spousteni v prostredi C++ Builderu
}

/* Tento program vypise

0 -1 2 -3 4 -5 6 -7 8 -9
-9 -7 -5 -3 -1 0 2 4 6 8
-9 8 -7 6 -5 4 -3 2 -1 0

*/